﻿#!/usr/bin/perl
#
#CactiHelper version 0.1, create some queries script/xml file for Cacti 8.6
#Copyright (C) 2005  Lechavalier Olivier <olivier.lechevalier@euromed-marseille.com>
#
#This program is free software; you can redistribute it and/or
#modify it under the terms of the GNU General Public License
#as published by the Free Software Foundation; either version 2
#of the License, or (at your option) any later version.
#
#This program is distributed in the hope that it will be useful,
#but WITHOUT ANY WARRANTY; without even the implied warranty of
#MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#GNU General Public License for more details.
#
#You should have received a copy of the GNU General Public License
#along with this program; if not, write to the Free Software
#Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

use encoding "utf8",STDOUT => "latin1",STDIN => "latin1";

if (($ARGV[1] ne "query") && ($ARGV[1] ne "get") && ($ARGV[1] ne "index")) {
	print "usage:\n\n./query_wmi_counters.pl ip index\n./query_wmi_counters.pl ip query {index,counter_name,value}\n./query_wmi_counter.pl ip get {index,counter_name,value} index\n";
	exit;
}

my $check_nt_path = "/usr/local/nagios/libexec/check_nt";

sub getValue{
	my($counter_name,$ip) = @_;
	my $ret = `$check_nt_path -H $ip -p 1248 -v COUNTER -l \"$counter_name\"`;
	chomp $ret;
	return($ret);
}



my @counters = ('\\\\Serveur SMTP(_Total)\Longueur file d\'attente locale',
'\\\\Serveur SMTP(_Total)\Longueur de la file d\'attente du catégorisateur',
'\\\\Serveur SMTP(_Total)\Longueur file d\'attente distante',
'\\\\MSExchangeIS Boîte aux lettres(_Total)\Taille de la file d\'attente pour envoi',
'\\\\MSExchangeIS Boîte aux lettres(_Total)\Taille de la file d\'attente pour réception',
'\\\\MSExchangeIS Public(_Total)\Receive Queue Size',
'\\\\MSExchangeIS Public(_Total)\Send Queue Size',
'\\\\MSExchangeIS\RPC Requests',
'\\\\MSExchangeIS\RPC Averaged Latency',
'\\\\Epoxy(DAV)\Client Out Queue Length',
'\\\\Epoxy(DAV)\Store Out Queue Length',
'\\\\Epoxy(DSAccess)\Client Out Queue Length',
'\\\\Epoxy(DSAccess)\Store Out Queue Length',
'\\\\Epoxy(IMAP)\Store Out Queue Length',
'\\\\Epoxy(IMAP)\Client Out Queue Length',
'\\\\Epoxy(NNTP)\Store Out Queue Length',
'\\\\Epoxy(NNTP)\Client Out Queue Length',
'\\\\Epoxy(POP3)\Client Out Queue Length',
'\\\\Epoxy(POP3)\Store Out Queue Length',
'\\\\Epoxy(SMTP)\Client Out Queue Length',
'\\\\Epoxy(SMTP)\Store Out Queue Length',
'\\\\Epoxy(_Total)\Store Out Queue Length',
'\\\\Epoxy(_Total)\Client Out Queue Length',
'\\\\Processus(store)\% Temps processeur',
'\\\\Processus(inetinfo)\% Temps processeur',
'\\\\Processus(emsmta)\% Temps processeur',
'\\\\Processus(System)\% Temps processeur',
'\\\\Disque physique(_Total)\Moy. disque s/lecture',
'\\\\Disque physique(_Total)\Moy. disque s/écriture',
'\\\\Disque physique(_Total)\Long. moy. de file d\'attente du disque',
'\\\\Base de données(Information Store)\Vidages du tampon journal saturé/s',
'\\\\Base de données(Information Store)\Vidages du tampon journal pour validation/s',
'\\\\Fichier d\'échange(_Total)\Pourcentage d\'utilisation',
'\\\\Mémoire\Méga-octets disponibles',
'\\\\Mémoire\Pages/s',
'\\\\Mémoire\Octets de réserve paginée',
'\\\\Mémoire\Octets de réserve non paginée',
'\\\\Mémoire\Entrées libres en table des pages sys.',
'\\\\MSExchangeIS\VM Largest Block Size',
'\\\\MSExchangeIS\VM Total 16MB Free Blocks',
'\\\\MSExchangeIS\VM Total Free Blocks',
'\\\\MSExchangeIS\VM Total Large Free Block Bytes',
'\\\\MSExchangeIS\Exchmem: Number of heaps with memory errors',
'\\\\MSExchangeIS\Exchmem: Number of memory errors',
'\\\\MSExchangeIS\Exchmem: Number of Additional Heaps',
'\\\\Processeur(_Total)\% Temps processeur',
'\\\\Système\Longueur de la file du processeur',
'\\\\Interface réseau(Intel[R] PRO_1000 MT Dual Port Network Connection)\Total des octets/sec',
'\\\\Interface réseau(Intel[R] PRO_1000 MT Dual Port Network Connection)\Paquets sortants, erreurs',
'\\\\Interface réseau(Intel[R] PRO_1000 MT Dual Port Network Connection#1)\Total des octets/sec',
'\\\\Interface réseau(Intel[R] PRO_1000 MT Dual Port Network Connection#1)\Paquets sortants jetés',
'\\\\Processus MSExchangeDSAccess(1164 WINMGMT.EXE)\Durée de lecture LDAP',
'\\\\Processus MSExchangeDSAccess(1164 WINMGMT.EXE)\Durée de recherche LDAP',
'\\\\Processus MSExchangeDSAccess(1236 INETINFO.EXE)\Durée de lecture LDAP',
'\\\\Processus MSExchangeDSAccess(1236 INETINFO.EXE)\Durée de recherche LDAP',
'\\\\Processus MSExchangeDSAccess(3112 MAD.EXE)\Durée de lecture LDAP',
'\\\\Processus MSExchangeDSAccess(3112 MAD.EXE)\Durée de recherche LDAP',
'\\\\Processus MSExchangeDSAccess(3344 STORE.EXE)\Durée de lecture LDAP',
'\\\\Processus MSExchangeDSAccess(3344 STORE.EXE)\Durée de recherche LDAP',
'\\\\Processus MSExchangeDSAccess(4572 EMSMTA.EXE)\Durée de lecture LDAP',
'\\\\Processus MSExchangeDSAccess(4572 EMSMTA.EXE)\Durée de recherche LDAP',
'\\\\MSExchangeIS Public(_Total)\Replication Receive Queue Size');



if($ARGV[1] eq "index") {
	for(my $i = 1;$i <= $#counters+1;$i++)
	{ print "$i\n"; }
	exit;
}

if($ARGV[1] eq "query"){
	if($ARGV[2] eq "index"){
			for(my $i = 1;$i <= $#counters+1;$i++)
			{	print "$i!$i\n";	}
			exit;
		}
		
		if($ARGV[2] eq "counter_name"){
			for(my $i = 1;$i <= $#counters+1;$i++)
			{	my $c = $counters[$i-1];
				$c =~ s/\\/\\\\/g;
				$c =~ s/'/''/g;
				print "$i!$c\n"; }
			exit;
		}
		
		if($ARGV[2] eq "value"){
				for(my $i = 1;$i <= $#counters+1;$i++){
					my $ret = getValue($counters[i-1],$ARGV[0]);
					print "$i!$ret\n";
				}
				exit;
		}
	exit;
}

if($ARGV[1] eq "get"){
	if($ARGV[2] eq "index"){
		print "$ARGV[3]\n";
		exit;
	}
	
	if($ARGV[2] eq "counter_name"){
		my $c = $counters[$ARGV[3]-1];
		$c =~ s/\\/\\\\/g;
		$c =~ s/'/''/g;
		print "$c\n";
		exit;
	}
	
	if($ARGV[2] eq "value"){
			
			my $ret = getValue($counters[$ARGV[3]-1],$ARGV[0]);
			print "$ret\n";
			exit;
	}
	exit;
}
	
		
